// Global scope contains user defined functions, and notifies the UI when
// they change.

using System.Collections.Generic;



class Globals : Dictionary<string, Function>
{
	public Globals() { }
	public Globals(Globals copy) : base(copy) { }



	// change notification event
	public delegate void ChangeHandler(Globals globals);

	public event ChangeHandler Changed;



	// tell the world when values are modified
	new public Function this [string key]
	{
		get {
			return base[key];
		}

		set {
			base[key] = value;

			if (Changed != null)
				Changed(this);
		}
	}
}
