// Generic pair type.

using System;



class Pair<T>
{
	// constructors
	public Pair()				{ }
	public Pair(T x, T y)		{ X = x; Y = y; }
	public Pair(Pair<T> pair)	{ X = pair.X; Y = pair.Y; }



	// a pair of values
	public T X;
	public T Y;



	// indexable by 0 or 1
	public T this [int index]
	{
		get {
			switch (index) {

				case 0: return X;
				case 1: return Y;

				default:
					throw new ArgumentOutOfRangeException();
			}
		}

		set {
			switch (index) {

				case 0: X = value; break;
				case 1: Y = value; break;

				default:
					throw new ArgumentOutOfRangeException();
			}
		}
	}
}


